# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IdActionrunsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'created_millis': 'int',
        'org_id': 'str',
        'run_state': 'str',
        'action_id': 'str',
        'action_type': 'str',
        'inputs': 'dict(str, object)',
        'outputs': 'dict(str, object)',
        'error_message': 'str',
        'logs': 'str',
        'triggered_by': 'str',
        'end_time_millis': 'int',
        'start_time_millis': 'int',
        'runtime': 'str',
        'provider': 'str',
        'source': 'str',
        'timeout_seconds': 'int',
        'project_id': 'str',
        'run_project_id': 'str',
        'scalable': 'bool',
        'action_version_id': 'str',
        'action_version_name': 'str',
        'configuration': 'dict(str, object)',
        'system': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'created_millis': 'createdMillis',
        'org_id': 'orgId',
        'run_state': 'runState',
        'action_id': 'actionId',
        'action_type': 'actionType',
        'inputs': 'inputs',
        'outputs': 'outputs',
        'error_message': 'errorMessage',
        'logs': 'logs',
        'triggered_by': 'triggeredBy',
        'end_time_millis': 'endTimeMillis',
        'start_time_millis': 'startTimeMillis',
        'runtime': 'runtime',
        'provider': 'provider',
        'source': 'source',
        'timeout_seconds': 'timeoutSeconds',
        'project_id': 'projectId',
        'run_project_id': 'runProjectId',
        'scalable': 'scalable',
        'action_version_id': 'actionVersionId',
        'action_version_name': 'actionVersionName',
        'configuration': 'configuration',
        'system': 'system'
    }

    def __init__(self, id=None, name=None, created_millis=None, org_id=None, run_state=None, action_id=None, action_type=None, inputs=None, outputs=None, error_message=None, logs=None, triggered_by=None, end_time_millis=None, start_time_millis=None, runtime=None, provider=None, source=None, timeout_seconds=None, project_id=None, run_project_id=None, scalable=None, action_version_id=None, action_version_name=None, configuration=None, system=None):  # noqa: E501
        """IdActionrunsBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._created_millis = None
        self._org_id = None
        self._run_state = None
        self._action_id = None
        self._action_type = None
        self._inputs = None
        self._outputs = None
        self._error_message = None
        self._logs = None
        self._triggered_by = None
        self._end_time_millis = None
        self._start_time_millis = None
        self._runtime = None
        self._provider = None
        self._source = None
        self._timeout_seconds = None
        self._project_id = None
        self._run_project_id = None
        self._scalable = None
        self._action_version_id = None
        self._action_version_name = None
        self._configuration = None
        self._system = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if created_millis is not None:
            self.created_millis = created_millis
        if org_id is not None:
            self.org_id = org_id
        if run_state is not None:
            self.run_state = run_state
        if action_id is not None:
            self.action_id = action_id
        if action_type is not None:
            self.action_type = action_type
        if inputs is not None:
            self.inputs = inputs
        if outputs is not None:
            self.outputs = outputs
        if error_message is not None:
            self.error_message = error_message
        if logs is not None:
            self.logs = logs
        if triggered_by is not None:
            self.triggered_by = triggered_by
        if end_time_millis is not None:
            self.end_time_millis = end_time_millis
        if start_time_millis is not None:
            self.start_time_millis = start_time_millis
        if runtime is not None:
            self.runtime = runtime
        if provider is not None:
            self.provider = provider
        if source is not None:
            self.source = source
        if timeout_seconds is not None:
            self.timeout_seconds = timeout_seconds
        if project_id is not None:
            self.project_id = project_id
        if run_project_id is not None:
            self.run_project_id = run_project_id
        if scalable is not None:
            self.scalable = scalable
        if action_version_id is not None:
            self.action_version_id = action_version_id
        if action_version_name is not None:
            self.action_version_name = action_version_name
        if configuration is not None:
            self.configuration = configuration
        if system is not None:
            self.system = system

    @property
    def id(self):
        """Gets the id of this IdActionrunsBody.  # noqa: E501


        :return: The id of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IdActionrunsBody.


        :param id: The id of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this IdActionrunsBody.  # noqa: E501


        :return: The name of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IdActionrunsBody.


        :param name: The name of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def created_millis(self):
        """Gets the created_millis of this IdActionrunsBody.  # noqa: E501


        :return: The created_millis of this IdActionrunsBody.  # noqa: E501
        :rtype: int
        """
        return self._created_millis

    @created_millis.setter
    def created_millis(self, created_millis):
        """Sets the created_millis of this IdActionrunsBody.


        :param created_millis: The created_millis of this IdActionrunsBody.  # noqa: E501
        :type: int
        """

        self._created_millis = created_millis

    @property
    def org_id(self):
        """Gets the org_id of this IdActionrunsBody.  # noqa: E501


        :return: The org_id of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this IdActionrunsBody.


        :param org_id: The org_id of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def run_state(self):
        """Gets the run_state of this IdActionrunsBody.  # noqa: E501


        :return: The run_state of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._run_state

    @run_state.setter
    def run_state(self, run_state):
        """Sets the run_state of this IdActionrunsBody.


        :param run_state: The run_state of this IdActionrunsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREATED", "DEPLOYING", "RUNNING", "FINISHING", "COMPLETED", "DEPLOYMENT_FAILED", "FAILED", "CANCELLED", "UNKNOWN", "DEPLOYED", "HANDLING_ERROR"]  # noqa: E501
        if run_state not in allowed_values:
            raise ValueError(
                "Invalid value for `run_state` ({0}), must be one of {1}"  # noqa: E501
                .format(run_state, allowed_values)
            )

        self._run_state = run_state

    @property
    def action_id(self):
        """Gets the action_id of this IdActionrunsBody.  # noqa: E501


        :return: The action_id of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._action_id

    @action_id.setter
    def action_id(self, action_id):
        """Sets the action_id of this IdActionrunsBody.


        :param action_id: The action_id of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._action_id = action_id

    @property
    def action_type(self):
        """Gets the action_type of this IdActionrunsBody.  # noqa: E501


        :return: The action_type of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._action_type

    @action_type.setter
    def action_type(self, action_type):
        """Sets the action_type of this IdActionrunsBody.


        :param action_type: The action_type of this IdActionrunsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["SCRIPT", "REST_CALL", "REST_POLL", "FLOW", "VAULT", "CYBERARK"]  # noqa: E501
        if action_type not in allowed_values:
            raise ValueError(
                "Invalid value for `action_type` ({0}), must be one of {1}"  # noqa: E501
                .format(action_type, allowed_values)
            )

        self._action_type = action_type

    @property
    def inputs(self):
        """Gets the inputs of this IdActionrunsBody.  # noqa: E501


        :return: The inputs of this IdActionrunsBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this IdActionrunsBody.


        :param inputs: The inputs of this IdActionrunsBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._inputs = inputs

    @property
    def outputs(self):
        """Gets the outputs of this IdActionrunsBody.  # noqa: E501


        :return: The outputs of this IdActionrunsBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._outputs

    @outputs.setter
    def outputs(self, outputs):
        """Sets the outputs of this IdActionrunsBody.


        :param outputs: The outputs of this IdActionrunsBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._outputs = outputs

    @property
    def error_message(self):
        """Gets the error_message of this IdActionrunsBody.  # noqa: E501


        :return: The error_message of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._error_message

    @error_message.setter
    def error_message(self, error_message):
        """Sets the error_message of this IdActionrunsBody.


        :param error_message: The error_message of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._error_message = error_message

    @property
    def logs(self):
        """Gets the logs of this IdActionrunsBody.  # noqa: E501


        :return: The logs of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._logs

    @logs.setter
    def logs(self, logs):
        """Sets the logs of this IdActionrunsBody.


        :param logs: The logs of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._logs = logs

    @property
    def triggered_by(self):
        """Gets the triggered_by of this IdActionrunsBody.  # noqa: E501


        :return: The triggered_by of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._triggered_by

    @triggered_by.setter
    def triggered_by(self, triggered_by):
        """Sets the triggered_by of this IdActionrunsBody.


        :param triggered_by: The triggered_by of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._triggered_by = triggered_by

    @property
    def end_time_millis(self):
        """Gets the end_time_millis of this IdActionrunsBody.  # noqa: E501


        :return: The end_time_millis of this IdActionrunsBody.  # noqa: E501
        :rtype: int
        """
        return self._end_time_millis

    @end_time_millis.setter
    def end_time_millis(self, end_time_millis):
        """Sets the end_time_millis of this IdActionrunsBody.


        :param end_time_millis: The end_time_millis of this IdActionrunsBody.  # noqa: E501
        :type: int
        """

        self._end_time_millis = end_time_millis

    @property
    def start_time_millis(self):
        """Gets the start_time_millis of this IdActionrunsBody.  # noqa: E501


        :return: The start_time_millis of this IdActionrunsBody.  # noqa: E501
        :rtype: int
        """
        return self._start_time_millis

    @start_time_millis.setter
    def start_time_millis(self, start_time_millis):
        """Sets the start_time_millis of this IdActionrunsBody.


        :param start_time_millis: The start_time_millis of this IdActionrunsBody.  # noqa: E501
        :type: int
        """

        self._start_time_millis = start_time_millis

    @property
    def runtime(self):
        """Gets the runtime of this IdActionrunsBody.  # noqa: E501


        :return: The runtime of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._runtime

    @runtime.setter
    def runtime(self, runtime):
        """Sets the runtime of this IdActionrunsBody.


        :param runtime: The runtime of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._runtime = runtime

    @property
    def provider(self):
        """Gets the provider of this IdActionrunsBody.  # noqa: E501


        :return: The provider of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this IdActionrunsBody.


        :param provider: The provider of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._provider = provider

    @property
    def source(self):
        """Gets the source of this IdActionrunsBody.  # noqa: E501


        :return: The source of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this IdActionrunsBody.


        :param source: The source of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def timeout_seconds(self):
        """Gets the timeout_seconds of this IdActionrunsBody.  # noqa: E501


        :return: The timeout_seconds of this IdActionrunsBody.  # noqa: E501
        :rtype: int
        """
        return self._timeout_seconds

    @timeout_seconds.setter
    def timeout_seconds(self, timeout_seconds):
        """Sets the timeout_seconds of this IdActionrunsBody.


        :param timeout_seconds: The timeout_seconds of this IdActionrunsBody.  # noqa: E501
        :type: int
        """

        self._timeout_seconds = timeout_seconds

    @property
    def project_id(self):
        """Gets the project_id of this IdActionrunsBody.  # noqa: E501


        :return: The project_id of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this IdActionrunsBody.


        :param project_id: The project_id of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def run_project_id(self):
        """Gets the run_project_id of this IdActionrunsBody.  # noqa: E501


        :return: The run_project_id of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._run_project_id

    @run_project_id.setter
    def run_project_id(self, run_project_id):
        """Sets the run_project_id of this IdActionrunsBody.


        :param run_project_id: The run_project_id of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._run_project_id = run_project_id

    @property
    def scalable(self):
        """Gets the scalable of this IdActionrunsBody.  # noqa: E501


        :return: The scalable of this IdActionrunsBody.  # noqa: E501
        :rtype: bool
        """
        return self._scalable

    @scalable.setter
    def scalable(self, scalable):
        """Sets the scalable of this IdActionrunsBody.


        :param scalable: The scalable of this IdActionrunsBody.  # noqa: E501
        :type: bool
        """

        self._scalable = scalable

    @property
    def action_version_id(self):
        """Gets the action_version_id of this IdActionrunsBody.  # noqa: E501


        :return: The action_version_id of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._action_version_id

    @action_version_id.setter
    def action_version_id(self, action_version_id):
        """Sets the action_version_id of this IdActionrunsBody.


        :param action_version_id: The action_version_id of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._action_version_id = action_version_id

    @property
    def action_version_name(self):
        """Gets the action_version_name of this IdActionrunsBody.  # noqa: E501


        :return: The action_version_name of this IdActionrunsBody.  # noqa: E501
        :rtype: str
        """
        return self._action_version_name

    @action_version_name.setter
    def action_version_name(self, action_version_name):
        """Sets the action_version_name of this IdActionrunsBody.


        :param action_version_name: The action_version_name of this IdActionrunsBody.  # noqa: E501
        :type: str
        """

        self._action_version_name = action_version_name

    @property
    def configuration(self):
        """Gets the configuration of this IdActionrunsBody.  # noqa: E501


        :return: The configuration of this IdActionrunsBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._configuration

    @configuration.setter
    def configuration(self, configuration):
        """Sets the configuration of this IdActionrunsBody.


        :param configuration: The configuration of this IdActionrunsBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._configuration = configuration

    @property
    def system(self):
        """Gets the system of this IdActionrunsBody.  # noqa: E501


        :return: The system of this IdActionrunsBody.  # noqa: E501
        :rtype: bool
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this IdActionrunsBody.


        :param system: The system of this IdActionrunsBody.  # noqa: E501
        :type: bool
        """

        self._system = system

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IdActionrunsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IdActionrunsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
